﻿package{
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	
	// Bibliothèque de gestion des collisions
	import com.coreyoneil.collision.CDK;
	import com.coreyoneil.collision.CollisionGroup;
	
	// Classe Représentant la balle
	public class Objet extends Balle{
		/* ENUMARATEURS */
		public static const MOUVEMENT:int = 1
		public static const CLIQUEE:int = 2
		public static const POSEE:int = 3
		public static const CONTACT:int = 4
		public static const SORTIE:int = 5
		public static const BARRE:int = 6
		
		/* ATTRIBUTS de l'Objet */
		private var oldX:Number
		private var oldY:Number
		private var vitX:Number
		private var vitY:Number
		
		private var poids:Number
		
		private var bouge:Boolean
		private var posee:Boolean
		private var contact:Boolean
		private var barre:Boolean
		private var cliquable:Boolean
		
		private var EnContact:Array
		
		// Constructeur de la balle
		public function Objet() {
			x = 550;
			y = -10;
			oldX = x;
			oldY = y;
			vitX = 0.0;
			vitY = 0.0;
			bouge = true;
			posee = false;
			contact = false;
			barre = false;
			cliquable = true;
			poids = 1.0;
			
			EnContact = new Array();
			
			this.addEventListener(MouseEvent.MOUSE_DOWN, bougeBalle);
			this.addEventListener(MouseEvent.MOUSE_UP, lacheBalle);
		}
		
		public function vitesse():Number{
			return Math.sqrt(Math.pow(this.vitX,2)+Math.pow(this.vitY,2));
		}
		
		// Correction doit déjà contenir les deux éléments à utiliser
		public function repositionner(correction:CollisionGroup):void{
			if(correction.checkCollisions().length > 0){
				while(correction.checkCollisions().length > 0){
					this.y --;
				}
				if(this.etat(550,400) == Objet.POSEE || this.vitesse() < 10) this.y ++;
			}else{
				while(correction.checkCollisions().length == 0){
					this.y ++;
				}
			}
		}
		
		public function collisionBalle(balle:Objet){
			var correction:CollisionGroup = new CollisionGroup(this,balle);
			// On regarde si les deux balles sont en contact
			if(correction.checkCollisions().length > 0 && (balle.etat(550,400) != Objet.POSEE || this.etat(550,400) != Objet.POSEE)){
				var balleHaute:Objet;
				var balleBasse:Objet;
				
				// Si c'est le cas, on détermine laquelle des deux est la plus haute
				balleHaute = this;
				balleBasse = this;
				if(this.y > balle.y) balleHaute = balle;
				else balleBasse = balle;
				
				if(!balleHaute.bouge) balleHaute.annulerSouris();
				// Puis on détermine où elles sont l'une par rapport à l'autre (côtés ou dessus/dessous)
				var angle:Number;
				angle = (balleHaute.y - balleBasse.y)/(balleHaute.x - balleBasse.x);
				
				// Si la balle la plus au dessus est sur l'un des côtés, alors on la déplace jusqu'à ce que
				// les deux images ne se chevauchent plus
				if(-1 <= angle && angle <= 1){
					var sens:int;
					sens = balleHaute.x - balleBasse.x;
					sens = sens / Math.abs(sens);
					while(balleHaute.hitTestObject(balleBasse)) balleHaute.x += sens;
				// Si les balles sont dessus/dessous, alors il y a deux possibilités
				}else{
					// Si la balle du dessous est stable (donc posée), alors la balle
					// du dessus viendra se poser et corrigera son chevauchement graphique
					var etat:int = balleBasse.etat(550,400);
					if((etat == Objet.POSEE || etat == Objet.BARRE) && balleHaute.vitesse() < 5){
						balleHaute.repositionner(correction);
						balleHaute.posee = true;
						
						balleHaute.EnContact.push(balleBasse);
						balleBasse.addPoids(balleHaute.poids);
					// Sinon, la balle du dessus et la balle du dessous se repoussent (réaction)
					}else{
						balleHaute.vitX += (balleHaute.x - balleBasse.x) / balleHaute.vitY;
						balleBasse.vitX += (balleBasse.x - balleHaute.x) / balleBasse.vitY;
						
						balleHaute.vitY *= -1;
						balleBasse.vitY *= -1;
					}
				}
			}
		}
		
		// Cette méthode permet de déterminer le poids soutenu par une Balle
		// Si une balle s'appuie sur plusieurs autres, alors le poids est réparti
		public function addPoids(p:Number):void{
			var i:int;
			this.poids += p;
			p = p/this.EnContact.length;
			for(i = 0;i < this.EnContact.length;i++){
				this.EnContact[i].addPoids(p);
			}
		}
		
		public function getPoids():Number{ return this.poids; }
		
		// On déplace la balle
		public function moves(poutre:MovieClip):void{
			if(bouge){
				if(!this.posee){
					this.vitY ++;
					
					this.oldX = x;
					this.oldY = y;
					
					this.x += this.vitX;
					this.y += this.vitY;
				}else if(!this.barre){
					var c:Boolean = false;
					var i:int;
					for(i = 0;i < this.EnContact.length;i++){
						c = (c || this.hitTestObject(this.EnContact[i]));
					}
					if(!c){
						this.mouvement();
						this.EnContact.slice(0,this.EnContact.length);
					}
				}
			}
		}
		
		// On réagit à une collision avec la Barre
		public function collisionBarre(poutre:MovieClip):void{
			if(!barre){
				this.vitY = -this.vitY/2;
				this.vitX = this.vitX/2;
				if(this.contact == true){
					this.posee = true;
					this.barre = true;
				}else{
					this.contact = true;
				}
			}
		}
		
		public function collisionPlanche(planche:MovieClip):void{
			this.vitY = -0.8;
			this.vitX = -2 - ((550 - this.x) * 0.03);
		}
		
		// Retourne l'état de la balle
		public function etat(w:Number,h:Number):int{
			if(this.barre) return Objet.BARRE;
			if(this.posee) return Objet.POSEE;
			if(this.contact) return Objet.CONTACT;
			if(this.dehors(w,h)) return Objet.SORTIE;
			if(this.bouge) return Objet.MOUVEMENT;
			return Objet.CLIQUEE;
		}
		
		// Attribue les valeurs d'une balle en mouvement
		public function mouvement():void{
			this.contact = false;
			this.posee = false;
		}
		
		// Attribue les valeurs d'une balle stable (posée)
		public function poser():void{
			this.vitX = 0.0;
			this.vitY = 0.0;
		}
		
		// Détecte si la balle sort de l'écran
		public function dehors(w:Number,h:Number):Boolean{
			var ret:Boolean;
			
			ret = !(0 < (this.x+this.width) && (this.x-this.width) < w);
			ret = ret || !(0 < (this.y+this.height) && (this.y-this.height) < h);
			
			return ret;
		}
		
		// Gère le déplacement de la balle par la souris
		function bougeBalle(ev:MouseEvent){
			if(!ev.target.posee && ev.target.cliquable){
				ev.target.bouge = false;
				ev.target.startDrag();
			}
		}
		
		// Gère le relachement de la balle par la souris
		function lacheBalle(ev:MouseEvent){
			ev.target.annulerSouris();
			/*ev.target.bouge = true;
			this.vitX = 0.0;
			this.vitY = 0.0;
			ev.target.stopDrag();*/
		}
		
		function annulerSouris(){
			this.cliquable = false;
			this.bouge = true;
			this.vitX = 0.0;
			this.vitY = 0.0;
			this.stopDrag();
		}
	}
}
